/*
 *  GateKey.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Sat Apr 17 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include "Object.h"
#include "WayGate.h"
#include "point3d.h"

#ifndef GATEKEY_H
#define GATEKEY_H

class GateKey : public Object {
public:
	GateKey(GLfloat x, GLfloat y, GLfloat z, GLfloat rad, WayGate *wg, double timeOut=5, bool _open=true); // start coord (3)
	~GateKey();
	int getDepthPlane() { return kFrontPlane; }
	point3d getLocation();
	void draw();
	uint32_t stepTime(double amount);
	double getRadius();
	void setColor();
	uint32_t testCollision(Object *);
	void destroy();
private:
		point3d loc;
	GLfloat radius;
	WayGate *door;
	double elapsedTime;
	double timeOut;
  bool open;
	int rv;
};

#endif