/*
 *  HomingMine.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Sun Apr 11 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include "Music.h"
#include "Object.h"
#include "point3d.h"

#ifndef HOMINGMINE_H
#define HOMINGMINE_H

class HomingMine : public Object {
public:
	//HomingMine(GLfloat *params, Object *target);
	HomingMine(GLfloat posx, GLfloat posy, GLfloat posz, Object *target);
	int getDepthPlane() { return kFrontPlane; }
	//Object *getNewObject();
	void draw();
	uint32_t stepTime(double amount);
	point3d getLocation();
	double getRadius() { return 0.05; }
	uint32_t testCollision(Object *);
	void setColor();
	void destroy();
  void arm();
private:
	void drawMine();
	Music *deployedMusic;
	double elapsedTime;
	int fragCount;
	int state;
	GLfloat param[6];
	Object *target;
	GLfloat fVel[3];
};

#endif