/*
 (MIT License)
 
 Copyright (c) 2004 NS Software
 
 Permission is hereby granted, free of charge, to any person obtaining a copy of this
 software and associated documentation files (the "Software"), to deal in the Software
 without restriction, including without limitation the rights to use, copy, modify,
 merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to the following
 conditions:
 
 The above copyright notice and this permission notice shall be included in all copies
 or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 */
/*
 *  Object.cpp
 *  Carbon OpenGL
 *
 *  Created by Nathan Sturtevant on Tue Mar 23 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include "Object.h"

Object::Object(	uint32_t oType, uint32_t tAgainst)
	:createdObjects(), objectType(oType), testWith(tAgainst)
{
		nextGoal = 0;
		activeGoal = false;
}

Object::~Object()
{
}

double Object::rand01()
{
	return ((double)(random()%54321)/54321.0);
}

point3d Object::getLocation() 
{
	point3d p;
	p.x = p.y = p.z = 0;
	return p;
}

uint32_t Object::testCollision(Object *o)
{
	return kNothingDestroyed;
//	kThisDestroyed,
//	kThatDestroyed,
//	kBothDestroyed
}

void Object::destroy()
{ }

void Object::pushCreatedObject(Object *o)
{
	if (o)
		createdObjects.push(o);
}

Object *Object::getNewObject()
{
	if (createdObjects.size() > 0)
	{
		Object *o = createdObjects.top();
		createdObjects.pop();
		return o;
	}
	return 0;
}


