/*
 *  Stars.h
 *  Carbon OpenGL
 *
 *  Created by Nathan Sturtevant on Wed Mar 24 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include "Object.h"
#include "point3d.h"
#include "vector3d.h"

#ifndef STARS_H
#define STARS_H

class Stars : public Object {
public:
  Stars(GLfloat x, GLfloat y, GLfloat z, int num);
  Stars(int num);
  ~Stars();
	void draw();
	int getDepthPlane() { return kBackPlane; }
  virtual uint32_t stepTime(double amount);
	void startRotating(double speed = 1.0);
private:
	bool rotate;
	double rotateDir, rotateSpeed;
	double elapsedTime;
	point3d *stars;
	int numStars;
  point3d middle;
	GLuint sList, uList;
};

#endif