/*
 *  TextBox.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Mon Apr 12 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include "Object.h"
#include "point3d.h"

#ifndef TEXTBOX_H
#define TEXTBOX_H

class TextBox : public Object {
public:
	TextBox(char *text, int charLine, point3d topLeft, point3d bottomRight, double duration=4, bool deform=true, bool scrolling = false); // start coord (3), velocity(3)
	~TextBox();
	int getDepthPlane() { return kFrontPlane; }
  uint32_t stepTime(double amount);
	void draw();
	point3d getLocation();
	void destroy();
private:
	void drawLine(point3d where, int startx, int starty, int offsetx, int offsety, double scale);
	void drawChar(char c, point3d where, double height);
	uint32_t getBitmap(char c);
	point3d tl, br;
	char *text;
	int charLine;
	bool deform, scrolling;
	double elapsedTime;
	double duration;
	GLuint dList;
};

#endif