/*
 *  Turret.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Sat Apr 17 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include "Object.h"
#include "point3d.h"

#ifndef TURRET_H
#define TURRET_H

enum {
	kDead,
	kTracking,
	kScanning
};

enum {
  kMine,
  kBullet
};

class Turret : public Object {
public:
	Turret(GLfloat x, GLfloat y, GLfloat z, Object *target, int what, GLfloat rad=.25, GLfloat fRate=5, GLfloat sSpeed = 8, GLfloat actRadius=30);
	~Turret();
	int getDepthPlane() { return kFrontPlane; }
	void draw();
  uint32_t stepTime(double amount);
	point3d getLocation();
	double getRadius();
	void setColor();
	uint32_t testCollision(Object *);
	void destroy();
  void activate();
private:
		point3d loc;
	double elapsedTime;
	double lastShot;
	double radius;
	double turnRate, fireRate, errorRate;
	double shotDamage;
	double health, shotSpeed;
  double activationRadius;
  bool creatingGoalObjects;
	int state;
  int create;
	Object *target;
};

#endif