#include <Carbon/Carbon.h>
#include <OpenGL/gl.h>
#include <AGL/agl.h>
#include "World.h"
#include "YourShip.h"
#include "TextBox.h"
#include "HighScores.h"
#include "LevelLoader.h"

enum {
	kFSAAOff = 0,
	kFSAAFast = 1,
	kFSAANice = 2,
	kSamples = 4
};

enum {
	kAtMainMenu,
	kInGame,
	kPaused,
	kWaitingClick,
	kBetweenLevels,
	kEnterHigh
};

// camera/context info
typedef struct {
   GLdouble x,y,z;
} recVec;

typedef struct {
/*	recVec viewPos; // View position
	recVec viewDir; // View direction vector
	recVec viewUp; // View up direction
	recVec rotPoint; // Point to rotate about */
	GLdouble aperture; // camera aperture
	GLint viewWidth,viewHeight; // current window/screen height and width
	GLfloat viewOriginX, viewOriginY; // always 0 
} recCamera;

// per view data
struct recContext
{
    // generic OpenGL stuff
	AGLPixelFormat aglPixFmt;
	AGLContext aglContext;
	GLuint boldFontList;
	GLuint regFontList;
	EventLoopTimerRef timer;
 
	DMExtendedNotificationUPP  windowEDMUPP;
   
	Boolean animate;
	Boolean info;
	Boolean drawHelp;
	Boolean drawCaps;
	Boolean polygons;
	Boolean lines;
	Boolean points;
	Boolean showCredits;
	long lighting;

	
	AbsoluteTime time;

	// spin
	//GLfloat fRot[4];
	//GLfloat fVel[3];
	GLfloat fAccel[3];
	
	// camera handling
	recCamera camera;
	//GLfloat worldRotation [4];
	//GLfloat objectRotation [4];
	//GLfloat shapeSize;
	
	char message[256]; // buffer for message output
	float msgTime; // message posting time for expiration
	
	int currentLevel;
	int gameState;
	int livesLeft, currentScore;
	World *world;
	YourShip *controlShip;
	TextBox *pauseMessage;
	TextBox *status, *sideRadar, *topRadar, *rearRadar;
	TextBox *level, *lives, *score, *ltime, *nssoftware;
	TextBox *highScore, *radarZoom;
	int zoom;
	char nameInitialsText[4];
	int nameInitialsIndex;
	TextBox *nameInitialsTextBox;
	HighScores *hs;
	LevelLoader *ll;
	long surface; 
	long colorScheme;
	unsigned long subdivisions;
	unsigned long xyRatio;
	
	long modeFSAA;
};
typedef struct recContext recContext;
typedef struct recContext * pRecContext;


// single set of interaction flags and states
extern GLfloat gTrackBallRotation [4];
extern pRecContext gContextTrackingInfo;

void updateProjection(pRecContext pContextInfo);
void drawGL (pRecContext pContextInfo, Boolean swap);
pRecContext GetCurrentContextInfo (WindowRef window);
void handleKeyboard(pRecContext pContextInfo, double rotation, double speed, double stop);

bool isPressed(unsigned short k );
void showPressed();
void getHeading(pRecContext pContextInfo, double &hx, double &hy, double &hz);
